Index: uspace/srv/net/il/ip/ip.c
===================================================================
--- uspace/srv/net/il/ip/ip.c	(revision 9414abc19106996bac61d12354e75953aa14bf29)
+++ uspace/srv/net/il/ip/ip.c	(revision 32efd865176bfa9c946bb85353ec87e270ab1dda)
@@ -28,15 +28,17 @@
 
 /** @addtogroup ip
- *  @{
+ * @{
  */
 
 /** @file
- *  IP module implementation.
- *  @see arp.h
- */
+ * IP module implementation.
+ * @see arp.h
+ */
+
+#include "ip.h"
+#include "ip_module.h"
 
 #include <async.h>
 #include <errno.h>
-#include <err.h>
 #include <fibril_synch.h>
 #include <stdio.h>
@@ -51,4 +53,8 @@
 #include <byteorder.h>
 
+#include <adt/measured_strings.h>
+#include <adt/module_map.h>
+
+#include <packet_client.h>
 #include <net/socket_codes.h>
 #include <net/in.h>
@@ -67,346 +73,185 @@
 #include <ip_client.h>
 #include <ip_interface.h>
+#include <ip_header.h>
 #include <net_interface.h>
 #include <nil_interface.h>
 #include <tl_interface.h>
-#include <adt/measured_strings.h>
-#include <adt/module_map.h>
-#include <packet_client.h>
 #include <packet_remote.h>
 #include <il_local.h>
 
-#include "ip.h"
-#include "ip_header.h"
-#include "ip_module.h"
-#include "ip_local.h"
-
-/** IP module name.
- */
-#define NAME  "ip"
-
-/** IP version 4.
- */
-#define IPV4				4
-
-/** Default network interface IP version.
- */
+/** IP module name. */
+#define NAME			"ip"
+
+/** IP version 4. */
+#define IPV4			4
+
+/** Default network interface IP version. */
 #define NET_DEFAULT_IPV		IPV4
 
-/** Default network interface IP routing.
- */
+/** Default network interface IP routing. */
 #define NET_DEFAULT_IP_ROUTING	false
 
-/** Minimum IP packet content.
- */
-#define IP_MIN_CONTENT	576
-
-/** ARP module name.
- */
-#define ARP_NAME				"arp"
-
-/** ARP module filename.
- */
-#define ARP_FILENAME			"/srv/arp"
-
-/** IP packet address length.
- */
-#define IP_ADDR							sizeof(struct sockaddr_in6)
-
-/** IP packet prefix length.
- */
-#define IP_PREFIX						sizeof(ip_header_t)
-
-/** IP packet suffix length.
- */
-#define IP_SUFFIX						0
-
-/** IP packet maximum content length.
- */
-#define IP_MAX_CONTENT					65535
-
-/** The IP localhost address.
- */
+/** Minimum IP packet content. */
+#define IP_MIN_CONTENT		576
+
+/** ARP module name. */
+#define ARP_NAME		"arp"
+
+/** ARP module filename. */
+#define ARP_FILENAME		"/srv/arp"
+
+/** IP packet address length. */
+#define IP_ADDR			sizeof(struct sockaddr_in6)
+
+/** IP packet prefix length. */
+#define IP_PREFIX		sizeof(ip_header_t)
+
+/** IP packet suffix length. */
+#define IP_SUFFIX		0
+
+/** IP packet maximum content length. */
+#define IP_MAX_CONTENT		65535
+
+/** The IP localhost address. */
 #define IPV4_LOCALHOST_ADDRESS	htonl((127 << 24) + 1)
 
-/** IP global data.
- */
-ip_globals_t	ip_globals;
-
-DEVICE_MAP_IMPLEMENT(ip_netifs, ip_netif_t)
-
-INT_MAP_IMPLEMENT(ip_protos, ip_proto_t)
-
-GENERIC_FIELD_IMPLEMENT(ip_routes, ip_route_t)
-
-/** Updates the device content length according to the new MTU value.
- *  @param[in] device_id The device identifier.
- *  @param[in] mtu The new mtu value.
- *  @returns EOK on success.
- *  @returns ENOENT if device is not found.
- */
-int ip_mtu_changed_message(device_id_t device_id, size_t mtu);
-
-/** Updates the device state.
- *  @param[in] device_id The device identifier.
- *  @param[in] state The new state value.
- *  @returns EOK on success.
- *  @returns ENOENT if device is not found.
- */
-int ip_device_state_message(device_id_t device_id, device_state_t state);
-
-/** Returns the device packet dimensions for sending.
- *  @param[in] phone The service module phone.
- *  @param[in] message The service specific message.
- *  @param[in] device_id The device identifier.
- *  @param[out] addr_len The minimum reserved address length.
- *  @param[out] prefix The minimum reserved prefix size.
- *  @param[out] content The maximum content size.
- *  @param[out] suffix The minimum reserved suffix size.
- *  @returns EOK on success.
- */
-int ip_packet_size_message(device_id_t device_id, size_t * addr_len, size_t * prefix, size_t * content, size_t * suffix);
-
-/** Registers the transport layer protocol.
- *  The traffic of this protocol will be supplied using either the receive function or IPC message.
- *  @param[in] protocol The transport layer module protocol.
- *  @param[in] service The transport layer module service.
- *  @param[in] phone The transport layer module phone.
- *  @param[in] tl_received_msg The receiving function.
- *  @returns EOK on success.
- *  @returns EINVAL if the protocol parameter and/or the service parameter is zero (0).
- *  @returns EINVAL if the phone parameter is not a positive number and the tl_receive_msg is NULL.
- *  @returns ENOMEM if there is not enough memory left.
- */
-int ip_register(int protocol, services_t service, int phone, tl_received_msg_t tl_received_msg);
-
-/** Initializes a new network interface specific data.
- *  Connects to the network interface layer module, reads the netif configuration, starts an ARP module if needed and sets the netif routing table.
- *  The device identifier and the nil service has to be set.
- *  @param[in,out] ip_netif Network interface specific data.
- *  @returns EOK on success.
- *  @returns ENOTSUP if DHCP is configured.
- *  @returns ENOTSUP if IPv6 is configured.
- *  @returns EINVAL if any of the addresses is invalid.
- *  @returns EINVAL if the used ARP module is not known.
- *  @returns ENOMEM if there is not enough memory left.
- *  @returns Other error codes as defined for the net_get_device_conf_req() function.
- *  @returns Other error codes as defined for the bind_service() function.
- *  @returns Other error codes as defined for the specific arp_device_req() function.
- *  @returns Other error codes as defined for the nil_packet_size_req() function.
- */
-int ip_netif_initialize(ip_netif_ref ip_netif);
-
-/** Sends the packet or the packet queue via the specified route.
- *  The ICMP_HOST_UNREACH error notification may be sent if route hardware destination address is found.
- *  @param[in,out] packet The packet to be sent.
- *  @param[in] netif The target network interface.
- *  @param[in] route The target route.
- *  @param[in] src The source address.
- *  @param[in] dest The destination address.
- *  @param[in] error The error module service.
- *  @returns EOK on success.
- *  @returns Other error codes as defined for the arp_translate_req() function.
- *  @returns Other error codes as defined for the ip_prepare_packet() function.
- */
-int ip_send_route(packet_t packet, ip_netif_ref netif, ip_route_ref route, in_addr_t * src, in_addr_t dest, services_t error);
-
-/** Prepares the outgoing packet or the packet queue.
- *  The packet queue is a fragmented packet
- *  Updates the first packet's IP header.
- *  Prefixes the additional packets with fragment headers.
- *  @param[in] source The source address.
- *  @param[in] dest The destination address.
- *  @param[in,out] packet The packet to be sent.
- *  @param[in] destination The destination hardware address.
- *  @returns EOK on success.
- *  @returns EINVAL if the packet is too small to contain the IP header.
- *  @returns EINVAL if the packet is too long than the IP allows.
- *  @returns ENOMEM if there is not enough memory left.
- *  @returns Other error codes as defined for the packet_set_addr() function.
- */
-int ip_prepare_packet(in_addr_t * source, in_addr_t dest, packet_t packet, measured_string_ref destination);
-
-/** Checks the packet queue lengths and fragments the packets if needed.
- *  The ICMP_FRAG_NEEDED error notification may be sent if the packet needs to be fragmented and the fragmentation is not allowed.
- *  @param[in,out] packet The packet or the packet queue to be checked.
- *  @param[in] prefix The minimum prefix size.
- *  @param[in] content The maximum content size.
- *  @param[in] suffix The minimum suffix size.
- *  @param[in] addr_len The minimum address length.
- *  @param[in] error The error module service.
- *  @returns The packet or the packet queue of the allowed length.
- *  @returns NULL if there are no packets left.
- */
-packet_t ip_split_packet(packet_t packet, size_t prefix, size_t content, size_t suffix, socklen_t addr_len, services_t error);
-
-/** Checks the packet length and fragments it if needed.
- *  The new fragments are queued before the original packet.
- *  @param[in,out] packet The packet to be checked.
- *  @param[in] length The maximum packet length.
- *  @param[in] prefix The minimum prefix size.
- *  @param[in] suffix The minimum suffix size.
- *  @param[in] addr_len The minimum address length.
- *  @returns EOK on success.
- *  @returns EINVAL if the packet_get_addr() function fails.
- *  @returns EINVAL if the packet does not contain the IP header.
- *  @returns EPERM if the packet needs to be fragmented and the fragmentation is not allowed.
- *  @returns ENOMEM if there is not enough memory left.
- *  @returns ENOMEM if there is no packet available.
- *  @returns ENOMEM if the packet is too small to contain the IP header.
- *  @returns Other error codes as defined for the packet_trim() function.
- *  @returns Other error codes as defined for the ip_create_middle_header() function.
- *  @returns Other error codes as defined for the ip_fragment_packet_data() function.
- */
-int ip_fragment_packet(packet_t packet, size_t length, size_t prefix, size_t suffix, socklen_t addr_len);
-
-/** Fragments the packet from the end.
- *  @param[in] packet The packet to be fragmented.
- *  @param[in,out] new_packet The new packet fragment.
- *  @param[in,out] header The original packet header.
- *  @param[in,out] new_header The new packet fragment header.
- *  @param[in] length The new fragment length.
- *  @param[in] src The source address.
- *  @param[in] dest The destiantion address.
- *  @param[in] addrlen The address length.
- *  @returns EOK on success.
- *  @returns ENOMEM if the target packet is too small.
- *  @returns Other error codes as defined for the packet_set_addr() function.
- *  @returns Other error codes as defined for the pq_insert_after() function.
- */
-int ip_fragment_packet_data(packet_t packet, packet_t new_packet, ip_header_ref header, ip_header_ref new_header, size_t length, const struct sockaddr * src, const struct sockaddr * dest, socklen_t addrlen);
-
-/** Prefixes a middle fragment header based on the last fragment header to the packet.
- *  @param[in] packet The packet to be prefixed.
- *  @param[in] last The last header to be copied.
- *  @returns The prefixed middle header.
- *  @returns NULL on error.
- */
-ip_header_ref ip_create_middle_header(packet_t packet, ip_header_ref last);
-
-/** Copies the fragment header.
- *  Copies only the header itself and relevant IP options.
- *  @param[out] last The created header.
- *  @param[in] first The original header to be copied.
- */
-void ip_create_last_header(ip_header_ref last, ip_header_ref first);
-
-/** Returns the network interface's IP address.
- *  @param[in] netif The network interface.
- *  @returns The IP address.
- *  @returns NULL if no IP address was found.
- */
-in_addr_t * ip_netif_address(ip_netif_ref netif);
-
-/** Searches all network interfaces if there is a suitable route.
- *  @param[in] destination The destination address.
- *  @returns The found route.
- *  @returns NULL if no route was found.
- */
-ip_route_ref ip_find_route(in_addr_t destination);
-
-/** Searches the network interfaces if there is a suitable route.
- *  @param[in] netif The network interface to be searched for routes. May be NULL.
- *  @param[in] destination The destination address.
- *  @returns The found route.
- *  @returns NULL if no route was found.
- */
-ip_route_ref ip_netif_find_route(ip_netif_ref netif, in_addr_t destination);
-
-/** Processes the received IP packet or the packet queue one by one.
- *  The packet is either passed to another module or released on error.
- *  @param[in] device_id The source device identifier.
- *  @param[in,out] packet The received packet.
- *  @returns EOK on success and the packet is no longer needed.
- *  @returns EINVAL if the packet is too small to carry the IP packet.
- *  @returns EINVAL if the received address lengths differs from the registered values.
- *  @returns ENOENT if the device is not found in the cache.
- *  @returns ENOENT if the protocol for the device is not found in the cache.
- *  @returns ENOMEM if there is not enough memory left.
- */
-int ip_receive_message(device_id_t device_id, packet_t packet);
-
-/** Processes the received packet.
- *  The packet is either passed to another module or released on error.
- *  The ICMP_PARAM_POINTER error notification may be sent if the checksum is invalid.
- *  The ICMP_EXC_TTL error notification may be sent if the TTL is less than two (2).
- *  The ICMP_HOST_UNREACH error notification may be sent if no route was found.
- *  The ICMP_HOST_UNREACH error notification may be sent if the packet is for another host and the routing is disabled.
- *  @param[in] device_id The source device identifier.
- *  @param[in] packet The received packet to be processed.
- *  @returns EOK on success.
- *  @returns EINVAL if the TTL is less than two (2).
- *  @returns EINVAL if the checksum is invalid.
- *  @returns EAFNOSUPPORT if the address family is not supported.
- *  @returns ENOENT if no route was found.
- *  @returns ENOENT if the packet is for another host and the routing is disabled.
- */
-int ip_process_packet(device_id_t device_id, packet_t packet);
-
-/** Returns the packet destination address from the IP header.
- *  @param[in] header The packet IP header to be read.
- *  @returns The packet destination address.
- */
-in_addr_t ip_get_destination(ip_header_ref header);
-
-/** Delivers the packet to the local host.
- *  The packet is either passed to another module or released on error.
- *  The ICMP_PROT_UNREACH error notification may be sent if the protocol is not found.
- *  @param[in] device_id The source device identifier.
- *  @param[in] packet The packet to be delivered.
- *  @param[in] header The first packet IP header. May be NULL.
- *  @param[in] error The packet error service.
- *  @returns EOK on success.
- *  @returns ENOTSUP if the packet is a fragment.
- *  @returns EAFNOSUPPORT if the address family is not supported.
- *  @returns ENOENT if the target protocol is not found.
- *  @returns Other error codes as defined for the packet_set_addr() function.
- *  @returns Other error codes as defined for the packet_trim() function.
- *  @returns Other error codes as defined for the protocol specific tl_received_msg function.
- */
-int ip_deliver_local(device_id_t device_id, packet_t packet, ip_header_ref header, services_t error);
+/** IP global data. */
+ip_globals_t ip_globals;
+
+DEVICE_MAP_IMPLEMENT(ip_netifs, ip_netif_t);
+INT_MAP_IMPLEMENT(ip_protos, ip_proto_t);
+GENERIC_FIELD_IMPLEMENT(ip_routes, ip_route_t);
+
+/** Releases the packet and returns the result.
+ *
+ * @param[in] packet	The packet queue to be released.
+ * @param[in] result	The result to be returned.
+ * @return		The result parameter.
+ */
+static int ip_release_and_return(packet_t packet, int result)
+{
+	pq_release_remote(ip_globals.net_phone, packet_get_id(packet));
+	return result;
+}
+
+/** Returns the ICMP phone.
+ *
+ * Searches the registered protocols.
+ *
+ * @returns		The found ICMP phone.
+ * @returns		ENOENT if the ICMP is not registered.
+ */
+static int ip_get_icmp_phone(void)
+{
+	ip_proto_ref proto;
+	int phone;
+
+	fibril_rwlock_read_lock(&ip_globals.protos_lock);
+	proto = ip_protos_find(&ip_globals.protos, IPPROTO_ICMP);
+	phone = proto ? proto->phone : ENOENT;
+	fibril_rwlock_read_unlock(&ip_globals.protos_lock);
+	return phone;
+}
 
 /** Prepares the ICMP notification packet.
- *  Releases additional packets and keeps only the first one.
- *  All packets is released on error.
- *  @param[in] error The packet error service.
- *  @param[in] packet The packet or the packet queue to be reported as faulty.
- *  @param[in] header The first packet IP header. May be NULL.
- *  @returns The found ICMP phone.
- *  @returns EINVAL if the error parameter is set.
- *  @returns EINVAL if the ICMP phone is not found.
- *  @returns EINVAL if the ip_prepare_icmp() fails.
- */
-int ip_prepare_icmp_and_get_phone(services_t error, packet_t packet, ip_header_ref header);
-
-/** Returns the ICMP phone.
- *  Searches the registered protocols.
- *  @returns The found ICMP phone.
- *  @returns ENOENT if the ICMP is not registered.
- */
-int ip_get_icmp_phone(void);
+ *
+ * Releases additional packets and keeps only the first one.
+ *
+ * @param[in] packet	The packet or the packet queue to be reported as faulty.
+ * @param[in] header	The first packet IP header. May be NULL.
+ * @returns		EOK on success.
+ * @returns		EINVAL if there are no data in the packet.
+ * @returns		EINVAL if the packet is a fragment.
+ * @returns		ENOMEM if the packet is too short to contain the IP
+ *			header.
+ * @returns		EAFNOSUPPORT if the address family is not supported.
+ * @returns		EPERM if the protocol is not allowed to send ICMP
+ *			notifications. The ICMP protocol itself.
+ * @returns		Other error codes as defined for the packet_set_addr().
+ */
+static int ip_prepare_icmp(packet_t packet, ip_header_ref header)
+{
+	packet_t next;
+	struct sockaddr *dest;
+	struct sockaddr_in dest_in;
+	socklen_t addrlen;
+
+	// detach the first packet and release the others
+	next = pq_detach(packet);
+	if (next)
+		pq_release_remote(ip_globals.net_phone, packet_get_id(next));
+
+	if (!header) {
+		if (packet_get_data_length(packet) <= sizeof(ip_header_t))
+			return ENOMEM;
+
+		// get header
+		header = (ip_header_ref) packet_get_data(packet);
+		if (!header)
+			return EINVAL;
+
+	}
+
+	// only for the first fragment
+	if (IP_FRAGMENT_OFFSET(header))
+		return EINVAL;
+
+	// not for the ICMP protocol
+	if (header->protocol == IPPROTO_ICMP)
+		return EPERM;
+
+	// set the destination address
+	switch (header->version) {
+	case IPVERSION:
+		addrlen = sizeof(dest_in);
+		bzero(&dest_in, addrlen);
+		dest_in.sin_family = AF_INET;
+		memcpy(&dest_in.sin_addr.s_addr, &header->source_address,
+		    sizeof(header->source_address));
+		dest = (struct sockaddr *) &dest_in;
+		break;
+
+	default:
+		return EAFNOSUPPORT;
+	}
+
+	return packet_set_addr(packet, NULL, (uint8_t *) dest, addrlen);
+}
 
 /** Prepares the ICMP notification packet.
- *  Releases additional packets and keeps only the first one.
- *  @param[in] packet The packet or the packet queue to be reported as faulty.
- *  @param[in] header The first packet IP header. May be NULL.
- *  @returns EOK on success.
- *  @returns EINVAL if there are no data in the packet.
- *  @returns EINVAL if the packet is a fragment.
- *  @returns ENOMEM if the packet is too short to contain the IP header.
- *  @returns EAFNOSUPPORT if the address family is not supported.
- *  @returns EPERM if the protocol is not allowed to send ICMP notifications. The ICMP protocol itself.
- *  @returns Other error codes as defined for the packet_set_addr().
- */
-int ip_prepare_icmp(packet_t packet, ip_header_ref header);
-
-/** Releases the packet and returns the result.
- *  @param[in] packet The packet queue to be released.
- *  @param[in] result The result to be returned.
- *  @return The result parameter.
- */
-int ip_release_and_return(packet_t packet, int result);
-
-int ip_initialize(async_client_conn_t client_connection){
-	ERROR_DECLARE;
+ *
+ * Releases additional packets and keeps only the first one.
+ * All packets are released on error.
+ *
+ * @param[in] error	The packet error service.
+ * @param[in] packet	The packet or the packet queue to be reported as faulty.
+ * @param[in] header	The first packet IP header. May be NULL.
+ * @returns		The found ICMP phone.
+ * @returns		EINVAL if the error parameter is set.
+ * @returns		EINVAL if the ICMP phone is not found.
+ * @returns		EINVAL if the ip_prepare_icmp() fails.
+ */
+static int
+ip_prepare_icmp_and_get_phone(services_t error, packet_t packet,
+    ip_header_ref header)
+{
+	int phone;
+
+	phone = ip_get_icmp_phone();
+	if (error || (phone < 0) || ip_prepare_icmp(packet, header))
+		return ip_release_and_return(packet, EINVAL);
+	return phone;
+}
+
+/** Initializes the IP module.
+ *
+ * @param[in] client_connection The client connection processing function. The
+ *			module skeleton propagates its own one.
+ * @returns		EOK on success.
+ * @returns		ENOMEM if there is not enough memory left.
+ */
+int ip_initialize(async_client_conn_t client_connection)
+{
+	int rc;
 
 	fibril_rwlock_initialize(&ip_globals.lock);
@@ -419,81 +264,92 @@
 	ip_globals.gateway.gateway.s_addr = 0;
 	ip_globals.gateway.netif = NULL;
-	ERROR_PROPAGATE(ip_netifs_initialize(&ip_globals.netifs));
-	ERROR_PROPAGATE(ip_protos_initialize(&ip_globals.protos));
 	ip_globals.client_connection = client_connection;
-	ERROR_PROPAGATE(modules_initialize(&ip_globals.modules));
-	ERROR_PROPAGATE(add_module(NULL, &ip_globals.modules, ARP_NAME, ARP_FILENAME, SERVICE_ARP, 0, arp_connect_module));
+	
+	rc = ip_netifs_initialize(&ip_globals.netifs);
+	if (rc != EOK)
+		goto out;
+	rc = ip_protos_initialize(&ip_globals.protos);
+	if (rc != EOK)
+		goto out;
+	rc = modules_initialize(&ip_globals.modules);
+	if (rc != EOK)
+		goto out;
+	rc = add_module(NULL, &ip_globals.modules, ARP_NAME, ARP_FILENAME,
+	    SERVICE_ARP, 0, arp_connect_module);
+
+out:
 	fibril_rwlock_write_unlock(&ip_globals.lock);
-	return EOK;
-}
-
-int ip_device_req_local(int il_phone, device_id_t device_id, services_t netif){
-	ERROR_DECLARE;
-
-	ip_netif_ref ip_netif;
-	ip_route_ref route;
-	int index;
-
-	ip_netif = (ip_netif_ref) malloc(sizeof(ip_netif_t));
-	if(! ip_netif){
-		return ENOMEM;
-	}
-	if(ERROR_OCCURRED(ip_routes_initialize(&ip_netif->routes))){
-		free(ip_netif);
-		return ERROR_CODE;
-	}
-	ip_netif->device_id = device_id;
-	ip_netif->service = netif;
-	ip_netif->state = NETIF_STOPPED;
-	fibril_rwlock_write_lock(&ip_globals.netifs_lock);
-	if(ERROR_OCCURRED(ip_netif_initialize(ip_netif))){
-		fibril_rwlock_write_unlock(&ip_globals.netifs_lock);
-		ip_routes_destroy(&ip_netif->routes);
-		free(ip_netif);
-		return ERROR_CODE;
-	}
-	if(ip_netif->arp){
-		++ ip_netif->arp->usage;
-	}
-	// print the settings
-	printf("%s: Device registered (id: %d, phone: %d, ipv: %d, conf: %s)\n",
-	    NAME, ip_netif->device_id, ip_netif->phone, ip_netif->ipv,
-	    ip_netif->dhcp ? "dhcp" : "static");
-	
-	// TODO ipv6 addresses
-	
-	char address[INET_ADDRSTRLEN];
-	char netmask[INET_ADDRSTRLEN];
-	char gateway[INET_ADDRSTRLEN];
-	
-	for (index = 0; index < ip_routes_count(&ip_netif->routes); ++ index){
-		route = ip_routes_get_index(&ip_netif->routes, index);
-		if (route) {
-			inet_ntop(AF_INET, (uint8_t *) &route->address.s_addr, address, INET_ADDRSTRLEN);
-			inet_ntop(AF_INET, (uint8_t *) &route->netmask.s_addr, netmask, INET_ADDRSTRLEN);
-			inet_ntop(AF_INET, (uint8_t *) &route->gateway.s_addr, gateway, INET_ADDRSTRLEN);
-			printf("%s: Route %d (address: %s, netmask: %s, gateway: %s)\n",
-			    NAME, index, address, netmask, gateway);
-		}
-	}
-	
-	inet_ntop(AF_INET, (uint8_t *) &ip_netif->broadcast.s_addr, address, INET_ADDRSTRLEN);
-	printf("%s: Broadcast (%s)\n", NAME, address);
-	
-	fibril_rwlock_write_unlock(&ip_globals.netifs_lock);
-	return EOK;
-}
-
-int ip_netif_initialize(ip_netif_ref ip_netif){
-	ERROR_DECLARE;
-
-	measured_string_t names[] = {{str_dup("IPV"), 3}, {str_dup("IP_CONFIG"), 9}, {str_dup("IP_ADDR"), 7}, {str_dup("IP_NETMASK"), 10}, {str_dup("IP_GATEWAY"), 10}, {str_dup("IP_BROADCAST"), 12}, {str_dup("ARP"), 3}, {str_dup("IP_ROUTING"), 10}};
+
+	return rc;
+}
+
+/** Initializes a new network interface specific data.
+ *
+ * Connects to the network interface layer module, reads the netif
+ * configuration, starts an ARP module if needed and sets the netif routing
+ * table.
+ * 
+ * The device identifier and the nil service has to be set.
+ *
+ * @param[in,out] ip_netif Network interface specific data.
+ * @returns		EOK on success.
+ * @returns		ENOTSUP if DHCP is configured.
+ * @returns		ENOTSUP if IPv6 is configured.
+ * @returns		EINVAL if any of the addresses is invalid.
+ * @returns		EINVAL if the used ARP module is not known.
+ * @returns		ENOMEM if there is not enough memory left.
+ * @returns		Other error codes as defined for the
+ *			net_get_device_conf_req() function.
+ * @returns		Other error codes as defined for the bind_service()
+ *			function.
+ * @returns		Other error codes as defined for the specific
+ *			arp_device_req() function.
+ * @returns		Other error codes as defined for the
+ *			nil_packet_size_req() function.
+ */
+static int ip_netif_initialize(ip_netif_ref ip_netif)
+{
+	measured_string_t names[] = {
+		{
+			(char *) "IPV",
+			3
+		},
+		{
+			(char *) "IP_CONFIG",
+			9
+		},
+		{
+			(char *) "IP_ADDR",
+			7
+		},
+		{
+			(char *) "IP_NETMASK",
+			10
+		},
+		{
+			(char *) "IP_GATEWAY",
+			10
+		},
+		{
+			(char *) "IP_BROADCAST",
+			12
+		},
+		{
+			(char *) "ARP",
+			3
+		},
+		{
+			(char *) "IP_ROUTING",
+			10
+		}
+	};
 	measured_string_ref configuration;
 	size_t count = sizeof(names) / sizeof(measured_string_t);
-	char * data;
+	char *data;
 	measured_string_t address;
-	int index;
 	ip_route_ref route;
 	in_addr_t gateway;
+	int index;
+	int rc;
 
 	ip_netif->arp = NULL;
@@ -503,18 +359,25 @@
 	ip_netif->routing = NET_DEFAULT_IP_ROUTING;
 	configuration = &names[0];
+
 	// get configuration
-	ERROR_PROPAGATE(net_get_device_conf_req(ip_globals.net_phone, ip_netif->device_id, &configuration, count, &data));
-	if(configuration){
-		if(configuration[0].value){
+	rc = net_get_device_conf_req(ip_globals.net_phone, ip_netif->device_id,
+	    &configuration, count, &data);
+	if (rc != EOK)
+		return rc;
+	
+	if (configuration) {
+		if (configuration[0].value)
 			ip_netif->ipv = strtol(configuration[0].value, NULL, 0);
-		}
-		ip_netif->dhcp = ! str_lcmp(configuration[1].value, "dhcp", configuration[1].length);
-		if(ip_netif->dhcp){
+
+		ip_netif->dhcp = !str_lcmp(configuration[1].value, "dhcp",
+		    configuration[1].length);
+		
+		if (ip_netif->dhcp) {
 			// TODO dhcp
 			net_free_settings(configuration, data);
 			return ENOTSUP;
-		}else if(ip_netif->ipv == IPV4){
+		} else if (ip_netif->ipv == IPV4) {
 			route = (ip_route_ref) malloc(sizeof(ip_route_t));
-			if(! route){
+			if (!route) {
 				net_free_settings(configuration, data);
 				return ENOMEM;
@@ -525,61 +388,88 @@
 			route->netif = ip_netif;
 			index = ip_routes_add(&ip_netif->routes, route);
-			if(index < 0){
+			if (index < 0) {
 				net_free_settings(configuration, data);
 				free(route);
 				return index;
 			}
-			if(ERROR_OCCURRED(inet_pton(AF_INET, configuration[2].value, (uint8_t *) &route->address.s_addr))
-				|| ERROR_OCCURRED(inet_pton(AF_INET, configuration[3].value, (uint8_t *) &route->netmask.s_addr))
-				|| (inet_pton(AF_INET, configuration[4].value, (uint8_t *) &gateway.s_addr) == EINVAL)
-				|| (inet_pton(AF_INET, configuration[5].value, (uint8_t *) &ip_netif->broadcast.s_addr) == EINVAL)){
+			
+			if ((inet_pton(AF_INET, configuration[2].value,
+			    (uint8_t *) &route->address.s_addr) != EOK) ||
+			    (inet_pton(AF_INET, configuration[3].value,
+			    (uint8_t *) &route->netmask.s_addr) != EOK) ||
+			    (inet_pton(AF_INET, configuration[4].value,
+			    (uint8_t *) &gateway.s_addr) == EINVAL) ||
+			    (inet_pton(AF_INET, configuration[5].value,
+			    (uint8_t *) &ip_netif->broadcast.s_addr) == EINVAL))
+			    {
 				net_free_settings(configuration, data);
 				return EINVAL;
 			}
-		}else{
+		} else {
 			// TODO ipv6 in separate module
 			net_free_settings(configuration, data);
 			return ENOTSUP;
 		}
-		if(configuration[6].value){
-			ip_netif->arp = get_running_module(&ip_globals.modules, configuration[6].value);
-			if(! ip_netif->arp){
-				printf("Failed to start the arp %s\n", configuration[6].value);
+
+		if (configuration[6].value) {
+			ip_netif->arp = get_running_module(&ip_globals.modules,
+			    configuration[6].value);
+			if (!ip_netif->arp) {
+				printf("Failed to start the arp %s\n",
+				    configuration[6].value);
 				net_free_settings(configuration, data);
 				return EINVAL;
 			}
 		}
-		if(configuration[7].value){
+		if (configuration[7].value)
 			ip_netif->routing = (configuration[7].value[0] == 'y');
-		}
+
 		net_free_settings(configuration, data);
 	}
+
 	// binds the netif service which also initializes the device
-	ip_netif->phone = nil_bind_service(ip_netif->service, (ipcarg_t) ip_netif->device_id, SERVICE_IP, ip_globals.client_connection);
-	if(ip_netif->phone < 0){
-		printf("Failed to contact the nil service %d\n", ip_netif->service);
+	ip_netif->phone = nil_bind_service(ip_netif->service,
+	    (ipcarg_t) ip_netif->device_id, SERVICE_IP,
+	    ip_globals.client_connection);
+	if (ip_netif->phone < 0) {
+		printf("Failed to contact the nil service %d\n",
+		    ip_netif->service);
 		return ip_netif->phone;
 	}
+
 	// has to be after the device netif module initialization
-	if(ip_netif->arp){
-		if(route){
+	if (ip_netif->arp) {
+		if (route) {
 			address.value = (char *) &route->address.s_addr;
 			address.length = CONVERT_SIZE(in_addr_t, char, 1);
-			ERROR_PROPAGATE(arp_device_req(ip_netif->arp->phone, ip_netif->device_id, SERVICE_IP, ip_netif->service, &address));
-		}else{
+			
+			rc = arp_device_req(ip_netif->arp->phone,
+			    ip_netif->device_id, SERVICE_IP, ip_netif->service,
+			    &address);
+			if (rc != EOK)
+				return rc;
+		} else {
 			ip_netif->arp = 0;
 		}
 	}
+
 	// get packet dimensions
-	ERROR_PROPAGATE(nil_packet_size_req(ip_netif->phone, ip_netif->device_id, &ip_netif->packet_dimension));
-	if(ip_netif->packet_dimension.content < IP_MIN_CONTENT){
-		printf("Maximum transmission unit %d bytes is too small, at least %d bytes are needed\n", ip_netif->packet_dimension.content, IP_MIN_CONTENT);
+	rc = nil_packet_size_req(ip_netif->phone, ip_netif->device_id,
+	    &ip_netif->packet_dimension);
+	if (rc != EOK)
+		return rc;
+	
+	if (ip_netif->packet_dimension.content < IP_MIN_CONTENT) {
+		printf("Maximum transmission unit %d bytes is too small, at "
+		    "least %d bytes are needed\n",
+		    ip_netif->packet_dimension.content, IP_MIN_CONTENT);
 		ip_netif->packet_dimension.content = IP_MIN_CONTENT;
 	}
+
 	index = ip_netifs_add(&ip_globals.netifs, ip_netif->device_id, ip_netif);
-	if(index < 0){
+	if (index < 0)
 		return index;
-	}
-	if(gateway.s_addr){
+	
+	if (gateway.s_addr) {
 		// the default gateway
 		ip_globals.gateway.address.s_addr = 0;
